local E, L, V, P, G = unpack(ElvUI)
local IsAddOnLoaded = IsAddOnLoaded
local format = string.format
local MyPluginName = "GennUI"
local GNUI = E:GetModule("GennUI");
local classColor = E:ClassColor(E.myclass, true)

function GNUI:SetupUnitframes()

-- Colors & Stuff
E.db["unitframe"]["colors"]["classResources"]["comboPoints"][1]["b"] = classColor.b
E.db["unitframe"]["colors"]["classResources"]["comboPoints"][1]["g"] = classColor.g
E.db["unitframe"]["colors"]["classResources"]["comboPoints"][1]["r"] = classColor.r
E.db["unitframe"]["colors"]["classResources"]["comboPoints"][2]["b"] = classColor.b
E.db["unitframe"]["colors"]["classResources"]["comboPoints"][2]["g"] = classColor.g
E.db["unitframe"]["colors"]["classResources"]["comboPoints"][2]["r"] = classColor.r
E.db["unitframe"]["colors"]["classResources"]["comboPoints"][3]["b"] = classColor.b
E.db["unitframe"]["colors"]["classResources"]["comboPoints"][3]["g"] = classColor.g
E.db["unitframe"]["colors"]["classResources"]["comboPoints"][3]["r"] = classColor.r
E.db["unitframe"]["colors"]["power"]["MANA"]["b"] = 2551 / 255
E.db["unitframe"]["colors"]["power"]["MANA"]["g"] = 209 / 255
E.db["unitframe"]["colors"]["power"]["MANA"]["r"] = 0 / 255
E.db["unitframe"]["colors"]["power"]["FOCUS"]["b"] = 15 / 255
E.db["unitframe"]["colors"]["power"]["FOCUS"]["g"] = 142 / 255
E.db["unitframe"]["colors"]["power"]["FOCUS"]["r"] = 255 / 255255
E.db["unitframe"]["colors"]["power"]["ENERGY"]["b"] = 31 / 255
E.db["unitframe"]["colors"]["power"]["ENERGY"]["g"] = 219 / 255
E.db["unitframe"]["colors"]["power"]["ENERGY"]["r"] = 230 / 255
E.db["unitframe"]["colors"]["power"]["RAGE"]["b"] = 31 / 255
E.db["unitframe"]["colors"]["power"]["RAGE"]["g"] = 31 / 255
E.db["unitframe"]["colors"]["power"]["RAGE"]["r"] = 199 / 255
E.db["unitframe"]["colors"]["auraBarDebuff"]["r"] = 79 / 255
E.db["unitframe"]["colors"]["auraBarDebuff"]["g"] = 79 / 255
E.db["unitframe"]["colors"]["auraBarDebuff"]["b"] = 79 / 255
E.db["unitframe"]["colors"]["health"]["r"] = 30 / 255
E.db["unitframe"]["colors"]["health"]["g"] = 30 / 255
E.db["unitframe"]["colors"]["health"]["b"] = 30 / 255
E.db["unitframe"]["colors"]["health_backdrop"]["r"] = 30 / 255
E.db["unitframe"]["colors"]["health_backdrop"]["g"] = 30 / 255
E.db["unitframe"]["colors"]["health_backdrop"]["b"] = 30 / 255
E.db["unitframe"]["colors"]["castColor"]["r"] = 0 / 255
E.db["unitframe"]["colors"]["castColor"]["g"] = 128 / 255
E.db["unitframe"]["colors"]["castColor"]["b"] = 255 / 255
E.db["unitframe"]["colors"]["castNoInterrupt"]["r"] = 200 / 255
E.db["unitframe"]["colors"]["castNoInterrupt"]["g"] = 20 / 255
E.db["unitframe"]["colors"]["castNoInterrupt"]["b"] = 20 / 255
E.db["unitframe"]["colors"]["castbar_backdrop"]["r"] = 30 / 255
E.db["unitframe"]["colors"]["castbar_backdrop"]["g"] = 30 / 255
E.db["unitframe"]["colors"]["castbar_backdrop"]["b"] = 30 / 255
E.db["unitframe"]["colors"]["healthMultiplier"] = 1
E.db["unitframe"]["colors"]["colorhealthbyvalue"] = false
E.db["unitframe"]["colors"]["debuffHighlight"]["Curse"]["a"] = 0.4
E.db["unitframe"]["colors"]["debuffHighlight"]["Disease"]["a"] = 0.4
E.db["unitframe"]["colors"]["debuffHighlight"]["Magic"]["a"] = 0.4
E.db["unitframe"]["colors"]["debuffHighlight"]["Poison"]["a"] = 0.4
E.db["unitframe"]["colors"]["debuffHighlight"]["blendMode"] = "ADD"
E.db["unitframe"]["debuffHighlighting"] = "FILL"
E.db["unitframe"]["colors"]["frameGlow"]["mouseoverGlow"]["enable"] = false
E.db["unitframe"]["colors"]["frameGlow"]["targetGlow"]["enable"] = false
E.db["unitframe"]["colors"]["healthclass"] = true
E.db["unitframe"]["colors"]["classbackdrop"] = false
E.db["unitframe"]["colors"]["customhealthbackdrop"] = true
E.db["unitframe"]["font"] = "Futura PT Medium"
E.db["unitframe"]["fontOutline"] = "OUTLINE"
E.db["unitframe"]["fontSize"] = 12
E.db["unitframe"]["smartRaidFilter"] = false
E.db["unitframe"]["smoothbars"] = true
E.db["unitframe"]["statusbar"] = "GennUI Melli"

--- Custom Texts
E.db["unitframe"]["units"]["player"]["customTexts"] = E.db["unitframe"]["units"]["player"]["customTexts"] or {}
E.db["unitframe"]["units"]["player"]["customTexts"]["gName"] = {}
E.db["unitframe"]["units"]["player"]["customTexts"]["gHealth"] = {}
E.db["unitframe"]["units"]["player"]["customTexts"]["gPower"] = {}
E.db["unitframe"]["units"]["player"]["customTexts"]["gMana"] = {}
E.db["unitframe"]["units"]["target"]["customTexts"] = E.db["unitframe"]["units"]["target"]["customTexts"] or {}
E.db["unitframe"]["units"]["target"]["customTexts"]["gName"] = {}
E.db["unitframe"]["units"]["target"]["customTexts"]["gHealth"] = {}
E.db["unitframe"]["units"]["target"]["customTexts"]["gPower"] = {}
E.db["unitframe"]["units"]["target"]["customTexts"]["gPercent"] = {}
E.db["unitframe"]["units"]["target"]["customTexts"]["gInfo"] = {}	
E.db["unitframe"]["units"]["party"]["customTexts"] = E.db["unitframe"]["units"]["party"]["customTexts"] or {}
E.db["unitframe"]["units"]["party"]["customTexts"]["gName"] = {}
E.db["unitframe"]["units"]["party"]["customTexts"]["gHealth"] = {}
E.db["unitframe"]["units"]["party"]["customTexts"]["gMana"] = {}

-- Assist
E.db["unitframe"]["units"]["assist"]["buffIndicator"]["countFontSize"] = 10
E.db["unitframe"]["units"]["assist"]["debuffs"]["anchorPoint"] = "RIGHT"
E.db["unitframe"]["units"]["assist"]["debuffs"]["countFont"] = "Futura PT Medium"
E.db["unitframe"]["units"]["assist"]["debuffs"]["countFontSize"] = 10
E.db["unitframe"]["units"]["assist"]["debuffs"]["enable"] = true
E.db["unitframe"]["units"]["assist"]["debuffs"]["perrow"] = 1
E.db["unitframe"]["units"]["assist"]["debuffs"]["priority"] = "RaidDebuffs,Boss"
E.db["unitframe"]["units"]["assist"]["debuffs"]["sizeOverride"] = 28
E.db["unitframe"]["units"]["assist"]["debuffs"]["xOffset"] = 1
E.db["unitframe"]["units"]["assist"]["debuffs"]["yOffset"] = 0
E.db["unitframe"]["units"]["assist"]["height"] = 25
E.db["unitframe"]["units"]["assist"]["name"]["text_format"] = "[name:medium]"
E.db["unitframe"]["units"]["assist"]["rdebuffs"]["font"] = "Futura PT Medium"
E.db["unitframe"]["units"]["assist"]["rdebuffs"]["fontOutline"] = "OUTLINE"
E.db["unitframe"]["units"]["assist"]["rdebuffs"]["onlyMatchSpellID"] = false
E.db["unitframe"]["units"]["assist"]["rdebuffs"]["size"] = 25
E.db["unitframe"]["units"]["assist"]["rdebuffs"]["stack"]["color"]["b"] = 1
E.db["unitframe"]["units"]["assist"]["rdebuffs"]["stack"]["color"]["g"] = 1
E.db["unitframe"]["units"]["assist"]["targetsGroup"]["enable"] = false
E.db["unitframe"]["units"]["assist"]["width"] = 100

-- Party
E.db["unitframe"]["units"]["party"]["buffIndicator"]["countFontSize"] = 10
E.db["unitframe"]["units"]["party"]["buffs"]["anchorPoint"] = "RIGHT"
E.db["unitframe"]["units"]["party"]["buffs"]["clickThrough"] = true
E.db["unitframe"]["units"]["party"]["buffs"]["countFont"] = "Futura PT Medium"
E.db["unitframe"]["units"]["party"]["buffs"]["countFontSize"] = 10
E.db["unitframe"]["units"]["party"]["buffs"]["enable"] = true
E.db["unitframe"]["units"]["party"]["buffs"]["perrow"] = 1
E.db["unitframe"]["units"]["party"]["buffs"]["sizeOverride"] = 28
E.db["unitframe"]["units"]["party"]["buffs"]["xOffset"] = -60
E.db["unitframe"]["units"]["party"]["buffs"]["yOffset"] = 12
E.db["unitframe"]["units"]["party"]["customTexts"]["gHealth"]["attachTextTo"] = "Health"
E.db["unitframe"]["units"]["party"]["customTexts"]["gHealth"]["enable"] = true
E.db["unitframe"]["units"]["party"]["customTexts"]["gHealth"]["font"] = "Futura PT Medium"
E.db["unitframe"]["units"]["party"]["customTexts"]["gHealth"]["fontOutline"] = "OUTLINE"
E.db["unitframe"]["units"]["party"]["customTexts"]["gHealth"]["justifyH"] = "RIGHT"
E.db["unitframe"]["units"]["party"]["customTexts"]["gHealth"]["size"] = 14
E.db["unitframe"]["units"]["party"]["customTexts"]["gHealth"]["text_format"] = "[health:current:shortvalue]"
E.db["unitframe"]["units"]["party"]["customTexts"]["gHealth"]["xOffset"] = 0
E.db["unitframe"]["units"]["party"]["customTexts"]["gHealth"]["yOffset"] = -8
E.db["unitframe"]["units"]["party"]["customTexts"]["gMana"]["attachTextTo"] = "Frame"
E.db["unitframe"]["units"]["party"]["customTexts"]["gMana"]["enable"] = false
E.db["unitframe"]["units"]["party"]["customTexts"]["gMana"]["font"] = "Futura PT Medium"
E.db["unitframe"]["units"]["party"]["customTexts"]["gMana"]["fontOutline"] = "OUTLINE"
E.db["unitframe"]["units"]["party"]["customTexts"]["gMana"]["justifyH"] = "RIGHT"
E.db["unitframe"]["units"]["party"]["customTexts"]["gMana"]["size"] = 10
E.db["unitframe"]["units"]["party"]["customTexts"]["gMana"]["text_format"] = "|cff00d1ff[gnuihmana]"
E.db["unitframe"]["units"]["party"]["customTexts"]["gMana"]["xOffset"] = 0
E.db["unitframe"]["units"]["party"]["customTexts"]["gMana"]["yOffset"] = 8
E.db["unitframe"]["units"]["party"]["customTexts"]["gName"]["attachTextTo"] = "Frame"
E.db["unitframe"]["units"]["party"]["customTexts"]["gName"]["enable"] = true
E.db["unitframe"]["units"]["party"]["customTexts"]["gName"]["font"] = "Futura PT Medium"
E.db["unitframe"]["units"]["party"]["customTexts"]["gName"]["fontOutline"] = "OUTLINE"
E.db["unitframe"]["units"]["party"]["customTexts"]["gName"]["justifyH"] = "LEFT"
E.db["unitframe"]["units"]["party"]["customTexts"]["gName"]["size"] = 16
E.db["unitframe"]["units"]["party"]["customTexts"]["gName"]["text_format"] = "[name:medium]"
E.db["unitframe"]["units"]["party"]["customTexts"]["gName"]["xOffset"] = 0
E.db["unitframe"]["units"]["party"]["customTexts"]["gName"]["yOffset"] = 6
E.db["unitframe"]["units"]["party"]["debuffs"]["perrow"] = 1
E.db["unitframe"]["units"]["party"]["debuffs"]["sizeOverride"] = 42
E.db["unitframe"]["units"]["party"]["debuffs"]["xOffset"] = 1
E.db["unitframe"]["units"]["party"]["healPrediction"]["enable"] = true
E.db["unitframe"]["units"]["party"]["health"]["text_format"] = ""
E.db["unitframe"]["units"]["party"]["height"] = 35
E.db["unitframe"]["units"]["party"]["name"]["text_format"] = ""
E.db["unitframe"]["units"]["party"]["petsGroup"]["anchorPoint"] = "BOTTOM"
E.db["unitframe"]["units"]["party"]["petsGroup"]["enable"] = true
E.db["unitframe"]["units"]["party"]["petsGroup"]["height"] = 8
E.db["unitframe"]["units"]["party"]["petsGroup"]["name"]["text_format"] = ""
E.db["unitframe"]["units"]["party"]["petsGroup"]["xOffset"] = 0
E.db["unitframe"]["units"]["party"]["power"]["enable"] = true
E.db["unitframe"]["units"]["party"]["power"]["height"] = 4
E.db["unitframe"]["units"]["party"]["power"]["text_format"] = ""
E.db["unitframe"]["units"]["party"]["power"]["width"] = "spaced"
E.db["unitframe"]["units"]["party"]["rdebuffs"]["font"] = "Futura PT Medium"
E.db["unitframe"]["units"]["party"]["rdebuffs"]["fontOutline"] = "OUTLINE"
E.db["unitframe"]["units"]["party"]["rdebuffs"]["fontSize"] = 12
E.db["unitframe"]["units"]["party"]["rdebuffs"]["onlyMatchSpellID"] = false
E.db["unitframe"]["units"]["party"]["rdebuffs"]["size"] = 22
E.db["unitframe"]["units"]["party"]["rdebuffs"]["stack"]["color"]["b"] = 1
E.db["unitframe"]["units"]["party"]["rdebuffs"]["stack"]["color"]["g"] = 1
E.db["unitframe"]["units"]["party"]["rdebuffs"]["xOffset"] = -10
E.db["unitframe"]["units"]["party"]["rdebuffs"]["yOffset"] = 6
E.db["unitframe"]["units"]["party"]["readycheckIcon"]["attachTo"] = "CENTER"
E.db["unitframe"]["units"]["party"]["readycheckIcon"]["size"] = 16
E.db["unitframe"]["units"]["party"]["readycheckIcon"]["yOffset"] = 0
E.db["unitframe"]["units"]["party"]["verticalSpacing"] = 12
E.db["unitframe"]["units"]["party"]["width"] = 140

-- Pet
E.db["unitframe"]["units"]["pet"]["buffIndicator"]["countFontSize"] = 10
E.db["unitframe"]["units"]["pet"]["castbar"]["enable"] = false
E.db["unitframe"]["units"]["pet"]["height"] = 25
E.db["unitframe"]["units"]["pet"]["name"]["attachTextTo"] = "Frame"
E.db["unitframe"]["units"]["pet"]["name"]["position"] = "TOPLEFT"
E.db["unitframe"]["units"]["pet"]["name"]["text_format"] = "[name:medium]"
E.db["unitframe"]["units"]["pet"]["name"]["yOffset"] = -4
E.db["unitframe"]["units"]["pet"]["power"]["enable"] = false
E.db["unitframe"]["units"]["pet"]["width"] = 100

-- Player
E.db["unitframe"]["units"]["player"]["CombatIcon"]["size"] = 32
E.db["unitframe"]["units"]["player"]["RestIcon"]["texture"] = "Resting0"
E.db["unitframe"]["units"]["player"]["RestIcon"]["xOffset"] = 0
E.db["unitframe"]["units"]["player"]["RestIcon"]["yOffset"] = 0
E.db["unitframe"]["units"]["player"]["aurabar"]["enable"] = false
E.db["unitframe"]["units"]["player"]["castbar"]["displayTarget"] = false
E.db["unitframe"]["units"]["player"]["castbar"]["iconAttached"] = false
E.db["unitframe"]["units"]["player"]["castbar"]["iconAttachedTo"] = "Castbar"
E.db["unitframe"]["units"]["player"]["castbar"]["iconSize"] = 32
E.db["unitframe"]["units"]["player"]["castbar"]["iconXOffset"] = 0
E.db["unitframe"]["units"]["player"]["castbar"]["width"] = 220
E.db["unitframe"]["units"]["player"]["classbar"]["autoHide"] = true
E.db["unitframe"]["units"]["player"]["classbar"]["detachedWidth"] = 180
E.db["unitframe"]["units"]["player"]["classbar"]["fill"] = "spaced"
E.db["unitframe"]["units"]["player"]["classbar"]["height"] = 4
E.db["unitframe"]["units"]["player"]["classbar"]["spacing"] = 2
E.db["unitframe"]["units"]["player"]["classbar"]["strataAndLevel"]["frameLevel"] = 2
E.db["unitframe"]["units"]["player"]["classbar"]["strataAndLevel"]["frameStrata"] = "HIGH"
E.db["unitframe"]["units"]["player"]["customTexts"]["gHealth"]["attachTextTo"] = "Frame"
E.db["unitframe"]["units"]["player"]["customTexts"]["gHealth"]["enable"] = true
E.db["unitframe"]["units"]["player"]["customTexts"]["gHealth"]["font"] = "Futura PT Medium"
E.db["unitframe"]["units"]["player"]["customTexts"]["gHealth"]["fontOutline"] = "OUTLINE"
E.db["unitframe"]["units"]["player"]["customTexts"]["gHealth"]["justifyH"] = "RIGHT"
E.db["unitframe"]["units"]["player"]["customTexts"]["gHealth"]["size"] = 18
E.db["unitframe"]["units"]["player"]["customTexts"]["gHealth"]["text_format"] = "[health:current:shortvalue]"
E.db["unitframe"]["units"]["player"]["customTexts"]["gHealth"]["xOffset"] = 0
E.db["unitframe"]["units"]["player"]["customTexts"]["gHealth"]["yOffset"] = -6
E.db["unitframe"]["units"]["player"]["customTexts"]["gMana"]["attachTextTo"] = "Frame"
E.db["unitframe"]["units"]["player"]["customTexts"]["gMana"]["enable"] = false
E.db["unitframe"]["units"]["player"]["customTexts"]["gMana"]["font"] = "Futura PT Medium"
E.db["unitframe"]["units"]["player"]["customTexts"]["gMana"]["fontOutline"] = "OUTLINE"
E.db["unitframe"]["units"]["player"]["customTexts"]["gMana"]["justifyH"] = "RIGHT"
E.db["unitframe"]["units"]["player"]["customTexts"]["gMana"]["size"] = 11
E.db["unitframe"]["units"]["player"]["customTexts"]["gMana"]["text_format"] = "|cff00d1ff[gnuihmana]"
E.db["unitframe"]["units"]["player"]["customTexts"]["gMana"]["xOffset"] = 0
E.db["unitframe"]["units"]["player"]["customTexts"]["gMana"]["yOffset"] = 8
E.db["unitframe"]["units"]["player"]["customTexts"]["gName"]["attachTextTo"] = "Frame"
E.db["unitframe"]["units"]["player"]["customTexts"]["gName"]["enable"] = true
E.db["unitframe"]["units"]["player"]["customTexts"]["gName"]["font"] = "Futura PT Medium"
E.db["unitframe"]["units"]["player"]["customTexts"]["gName"]["fontOutline"] = "OUTLINE"
E.db["unitframe"]["units"]["player"]["customTexts"]["gName"]["justifyH"] = "LEFT"
E.db["unitframe"]["units"]["player"]["customTexts"]["gName"]["size"] = 18
E.db["unitframe"]["units"]["player"]["customTexts"]["gName"]["text_format"] = "[name:long]"
E.db["unitframe"]["units"]["player"]["customTexts"]["gName"]["xOffset"] = 0
E.db["unitframe"]["units"]["player"]["customTexts"]["gName"]["yOffset"] = 5
E.db["unitframe"]["units"]["player"]["customTexts"]["gPower"]["attachTextTo"] = "Frame"
E.db["unitframe"]["units"]["player"]["customTexts"]["gPower"]["enable"] = true
E.db["unitframe"]["units"]["player"]["customTexts"]["gPower"]["font"] = "Futura PT Medium"
E.db["unitframe"]["units"]["player"]["customTexts"]["gPower"]["fontOutline"] = "OUTLINE"
E.db["unitframe"]["units"]["player"]["customTexts"]["gPower"]["justifyH"] = "LEFT"
E.db["unitframe"]["units"]["player"]["customTexts"]["gPower"]["size"] = 12
E.db["unitframe"]["units"]["player"]["customTexts"]["gPower"]["text_format"] = "[powercolor][power:current:shortvalue]"
E.db["unitframe"]["units"]["player"]["customTexts"]["gPower"]["xOffset"] = 0
E.db["unitframe"]["units"]["player"]["customTexts"]["gPower"]["yOffset"] = -10
E.db["unitframe"]["units"]["player"]["debuffs"]["countFont"] = "Futura PT Medium"
E.db["unitframe"]["units"]["player"]["debuffs"]["enable"] = false
E.db["unitframe"]["units"]["player"]["fader"]["hover"] = false
E.db["unitframe"]["units"]["player"]["fader"]["playertarget"] = false
E.db["unitframe"]["units"]["player"]["health"]["text_format"] = ""
E.db["unitframe"]["units"]["player"]["height"] = 35
E.db["unitframe"]["units"]["player"]["power"]["detachedWidth"] = 120
E.db["unitframe"]["units"]["player"]["power"]["enable"] = false
E.db["unitframe"]["units"]["player"]["power"]["height"] = 4
E.db["unitframe"]["units"]["player"]["power"]["text_format"] = ""
E.db["unitframe"]["units"]["player"]["power"]["width"] = "spaced"
E.db["unitframe"]["units"]["player"]["pvp"]["text_format"] = ""
E.db["unitframe"]["units"]["player"]["raidicon"]["attachTo"] = "CENTER"
E.db["unitframe"]["units"]["player"]["raidicon"]["size"] = 22
E.db["unitframe"]["units"]["player"]["raidicon"]["xOffset"] = 22
E.db["unitframe"]["units"]["player"]["raidicon"]["yOffset"] = 0
E.db["unitframe"]["units"]["player"]["width"] = 220

-- Raid
E.db["unitframe"]["units"]["raid"]["buffIndicator"]["countFontSize"] = 10
E.db["unitframe"]["units"]["raid"]["healPrediction"]["enable"] = true
E.db["unitframe"]["units"]["raid"]["health"]["text_format"] = ""
E.db["unitframe"]["units"]["raid"]["height"] = 35
E.db["unitframe"]["units"]["raid"]["horizontalSpacing"] = 1
E.db["unitframe"]["units"]["raid"]["name"]["text_format"] = "[name:medium]"
E.db["unitframe"]["units"]["raid"]["power"]["enable"] = false
E.db["unitframe"]["units"]["raid"]["power"]["height"] = 4
E.db["unitframe"]["units"]["raid"]["power"]["width"] = "spaced"
E.db["unitframe"]["units"]["raid"]["raidicon"]["size"] = 16
E.db["unitframe"]["units"]["raid"]["rdebuffs"]["duration"]["color"]["b"] = 1
E.db["unitframe"]["units"]["raid"]["rdebuffs"]["duration"]["color"]["g"] = 1
E.db["unitframe"]["units"]["raid"]["rdebuffs"]["font"] = "Futura PT Medium"
E.db["unitframe"]["units"]["raid"]["rdebuffs"]["fontOutline"] = "OUTLINE"
E.db["unitframe"]["units"]["raid"]["rdebuffs"]["onlyMatchSpellID"] = false
E.db["unitframe"]["units"]["raid"]["rdebuffs"]["stack"]["color"]["b"] = 1
E.db["unitframe"]["units"]["raid"]["rdebuffs"]["stack"]["color"]["g"] = 1
E.db["unitframe"]["units"]["raid"]["rdebuffs"]["yOffset"] = 4
E.db["unitframe"]["units"]["raid"]["readycheckIcon"]["attachTo"] = "CENTER"
E.db["unitframe"]["units"]["raid"]["readycheckIcon"]["size"] = 16
E.db["unitframe"]["units"]["raid"]["verticalSpacing"] = 1

-- Raid40
E.db["unitframe"]["units"]["raid40"]["buffIndicator"]["countFontSize"] = 10
E.db["unitframe"]["units"]["raid40"]["healPrediction"]["enable"] = true
E.db["unitframe"]["units"]["raid40"]["health"]["text_format"] = ""
E.db["unitframe"]["units"]["raid40"]["height"] = 22
E.db["unitframe"]["units"]["raid40"]["horizontalSpacing"] = 1
E.db["unitframe"]["units"]["raid40"]["name"]["text_format"] = "[name:medium]"
E.db["unitframe"]["units"]["raid40"]["raidicon"]["size"] = 16
E.db["unitframe"]["units"]["raid40"]["rdebuffs"]["enable"] = true
E.db["unitframe"]["units"]["raid40"]["rdebuffs"]["font"] = "Futura PT Medium"
E.db["unitframe"]["units"]["raid40"]["rdebuffs"]["fontOutline"] = "OUTLINE"
E.db["unitframe"]["units"]["raid40"]["rdebuffs"]["onlyMatchSpellID"] = false
E.db["unitframe"]["units"]["raid40"]["rdebuffs"]["size"] = 22
E.db["unitframe"]["units"]["raid40"]["rdebuffs"]["stack"]["color"]["b"] = 1
E.db["unitframe"]["units"]["raid40"]["rdebuffs"]["stack"]["color"]["g"] = 1
E.db["unitframe"]["units"]["raid40"]["readycheckIcon"]["attachTo"] = "CENTER"
E.db["unitframe"]["units"]["raid40"]["verticalSpacing"] = 1

-- Tank
E.db["unitframe"]["units"]["tank"]["buffIndicator"]["countFontSize"] = 10
E.db["unitframe"]["units"]["tank"]["buffs"]["countFont"] = "Futura PT Medium"
E.db["unitframe"]["units"]["tank"]["buffs"]["countFontSize"] = 10
E.db["unitframe"]["units"]["tank"]["debuffs"]["anchorPoint"] = "RIGHT"
E.db["unitframe"]["units"]["tank"]["debuffs"]["countFont"] = "Futura PT Medium"
E.db["unitframe"]["units"]["tank"]["debuffs"]["countFontSize"] = 10
E.db["unitframe"]["units"]["tank"]["debuffs"]["enable"] = true
E.db["unitframe"]["units"]["tank"]["debuffs"]["perrow"] = 1
E.db["unitframe"]["units"]["tank"]["debuffs"]["priority"] = "RaidDebuffs,Boss"
E.db["unitframe"]["units"]["tank"]["debuffs"]["sizeOverride"] = 28
E.db["unitframe"]["units"]["tank"]["debuffs"]["xOffset"] = 1
E.db["unitframe"]["units"]["tank"]["debuffs"]["yOffset"] = 0
E.db["unitframe"]["units"]["tank"]["height"] = 25
E.db["unitframe"]["units"]["tank"]["name"]["text_format"] = "[name:medium]"
E.db["unitframe"]["units"]["tank"]["rdebuffs"]["font"] = "Futura PT Medium"
E.db["unitframe"]["units"]["tank"]["rdebuffs"]["fontOutline"] = "OUTLINE"
E.db["unitframe"]["units"]["tank"]["rdebuffs"]["onlyMatchSpellID"] = false
E.db["unitframe"]["units"]["tank"]["rdebuffs"]["size"] = 25
E.db["unitframe"]["units"]["tank"]["rdebuffs"]["stack"]["color"]["b"] = 1
E.db["unitframe"]["units"]["tank"]["rdebuffs"]["stack"]["color"]["g"] = 1
E.db["unitframe"]["units"]["tank"]["targetsGroup"]["enable"] = false
E.db["unitframe"]["units"]["tank"]["width"] = 100

-- Target
E.db["unitframe"]["units"]["target"]["CombatIcon"]["size"] = 32
E.db["unitframe"]["units"]["target"]["aurabar"]["attachTo"] = "BUFFS"
E.db["unitframe"]["units"]["target"]["aurabar"]["height"] = 16
E.db["unitframe"]["units"]["target"]["aurabar"]["priority"] = "Blacklist,blockNoDuration,CCDebuffs,Personal,Boss,RaidDebuffs,PlayerBuffs"
E.db["unitframe"]["units"]["target"]["aurabar"]["yOffset"] = 1
E.db["unitframe"]["units"]["target"]["buffs"]["anchorPoint"] = "TOPLEFT"
E.db["unitframe"]["units"]["target"]["buffs"]["countFont"] = "Futura PT Medium"
E.db["unitframe"]["units"]["target"]["buffs"]["countFontSize"] = 10
E.db["unitframe"]["units"]["target"]["buffs"]["priority"] = "Blacklist,Dispellable,Personal,nonPersonal"
E.db["unitframe"]["units"]["target"]["castbar"]["iconAttached"] = false
E.db["unitframe"]["units"]["target"]["castbar"]["iconAttachedTo"] = "Castbar"
E.db["unitframe"]["units"]["target"]["castbar"]["iconPosition"] = "RIGHT"
E.db["unitframe"]["units"]["target"]["castbar"]["iconSize"] = 32
E.db["unitframe"]["units"]["target"]["castbar"]["iconXOffset"] = 1
E.db["unitframe"]["units"]["target"]["castbar"]["width"] = 220
E.db["unitframe"]["units"]["target"]["customTexts"]["gHealth"]["attachTextTo"] = "Frame"
E.db["unitframe"]["units"]["target"]["customTexts"]["gHealth"]["enable"] = true
E.db["unitframe"]["units"]["target"]["customTexts"]["gHealth"]["font"] = "Futura PT Medium"
E.db["unitframe"]["units"]["target"]["customTexts"]["gHealth"]["fontOutline"] = "OUTLINE"
E.db["unitframe"]["units"]["target"]["customTexts"]["gHealth"]["justifyH"] = "LEFT"
E.db["unitframe"]["units"]["target"]["customTexts"]["gHealth"]["size"] = 18
E.db["unitframe"]["units"]["target"]["customTexts"]["gHealth"]["text_format"] = "[health:current:shortvalue]"
E.db["unitframe"]["units"]["target"]["customTexts"]["gHealth"]["xOffset"] = 0
E.db["unitframe"]["units"]["target"]["customTexts"]["gHealth"]["yOffset"] = -6
E.db["unitframe"]["units"]["target"]["customTexts"]["gInfo"]["attachTextTo"] = "Frame"
E.db["unitframe"]["units"]["target"]["customTexts"]["gInfo"]["enable"] = true
E.db["unitframe"]["units"]["target"]["customTexts"]["gInfo"]["font"] = "Futura PT Medium"
E.db["unitframe"]["units"]["target"]["customTexts"]["gInfo"]["fontOutline"] = "OUTLINE"
E.db["unitframe"]["units"]["target"]["customTexts"]["gInfo"]["justifyH"] = "CENTER"
E.db["unitframe"]["units"]["target"]["customTexts"]["gInfo"]["size"] = 12
E.db["unitframe"]["units"]["target"]["customTexts"]["gInfo"]["text_format"] = "[namecolor][smartclass] ||cffffffff LvL ||r[difficultycolor][level] [classification]"
E.db["unitframe"]["units"]["target"]["customTexts"]["gInfo"]["xOffset"] = 0
E.db["unitframe"]["units"]["target"]["customTexts"]["gInfo"]["yOffset"] = -24
E.db["unitframe"]["units"]["target"]["customTexts"]["gName"]["attachTextTo"] = "Frame"
E.db["unitframe"]["units"]["target"]["customTexts"]["gName"]["enable"] = true
E.db["unitframe"]["units"]["target"]["customTexts"]["gName"]["font"] = "Futura PT Medium"
E.db["unitframe"]["units"]["target"]["customTexts"]["gName"]["fontOutline"] = "OUTLINE"
E.db["unitframe"]["units"]["target"]["customTexts"]["gName"]["justifyH"] = "RIGHT"
E.db["unitframe"]["units"]["target"]["customTexts"]["gName"]["size"] = 18
E.db["unitframe"]["units"]["target"]["customTexts"]["gName"]["text_format"] = "[name:abbrev:long]"
E.db["unitframe"]["units"]["target"]["customTexts"]["gName"]["xOffset"] = 0
E.db["unitframe"]["units"]["target"]["customTexts"]["gName"]["yOffset"] = 5
E.db["unitframe"]["units"]["target"]["customTexts"]["gPercent"]["attachTextTo"] = "Frame"
E.db["unitframe"]["units"]["target"]["customTexts"]["gPercent"]["enable"] = true
E.db["unitframe"]["units"]["target"]["customTexts"]["gPercent"]["font"] = "Century Gothic Bold"
E.db["unitframe"]["units"]["target"]["customTexts"]["gPercent"]["fontOutline"] = "OUTLINE"
E.db["unitframe"]["units"]["target"]["customTexts"]["gPercent"]["justifyH"] = "LEFT"
E.db["unitframe"]["units"]["target"]["customTexts"]["gPercent"]["size"] = 10
E.db["unitframe"]["units"]["target"]["customTexts"]["gPercent"]["text_format"] = "[perhp]%"
E.db["unitframe"]["units"]["target"]["customTexts"]["gPercent"]["xOffset"] = 0
E.db["unitframe"]["units"]["target"]["customTexts"]["gPercent"]["yOffset"] = 8
E.db["unitframe"]["units"]["target"]["customTexts"]["gPower"]["attachTextTo"] = "Frame"
E.db["unitframe"]["units"]["target"]["customTexts"]["gPower"]["enable"] = true
E.db["unitframe"]["units"]["target"]["customTexts"]["gPower"]["font"] = "Futura PT Medium"
E.db["unitframe"]["units"]["target"]["customTexts"]["gPower"]["fontOutline"] = "OUTLINE"
E.db["unitframe"]["units"]["target"]["customTexts"]["gPower"]["justifyH"] = "RIGHT"
E.db["unitframe"]["units"]["target"]["customTexts"]["gPower"]["size"] = 12
E.db["unitframe"]["units"]["target"]["customTexts"]["gPower"]["text_format"] = "[powercolor][power:current:shortvalue]"
E.db["unitframe"]["units"]["target"]["customTexts"]["gPower"]["xOffset"] = 0
E.db["unitframe"]["units"]["target"]["customTexts"]["gPower"]["yOffset"] = -8
E.db["unitframe"]["units"]["target"]["debuffs"]["anchorPoint"] = "RIGHT"
E.db["unitframe"]["units"]["target"]["debuffs"]["attachTo"] = "FRAME"
E.db["unitframe"]["units"]["target"]["debuffs"]["countFont"] = "Futura PT Medium"
E.db["unitframe"]["units"]["target"]["debuffs"]["countFontSize"] = 16
E.db["unitframe"]["units"]["target"]["debuffs"]["perrow"] = 3
E.db["unitframe"]["units"]["target"]["debuffs"]["priority"] = "Blacklist,blockNoDuration,CCDebuffs,Friendly:Dispellable,Personal,RaidDebuffs"
E.db["unitframe"]["units"]["target"]["debuffs"]["sizeOverride"] = 42
E.db["unitframe"]["units"]["target"]["debuffs"]["xOffset"] = 1
E.db["unitframe"]["units"]["target"]["health"]["text_format"] = ""
E.db["unitframe"]["units"]["target"]["height"] = 35
E.db["unitframe"]["units"]["target"]["name"]["text_format"] = ""
E.db["unitframe"]["units"]["target"]["power"]["enable"] = false
E.db["unitframe"]["units"]["target"]["power"]["height"] = 4
E.db["unitframe"]["units"]["target"]["power"]["text_format"] = ""
E.db["unitframe"]["units"]["target"]["power"]["width"] = "spaced"
E.db["unitframe"]["units"]["target"]["width"] = 220

-- Target's Target
E.db["unitframe"]["units"]["targettarget"]["buffs"]["countFont"] = "Futura PT Medium"
E.db["unitframe"]["units"]["targettarget"]["debuffs"]["attachTo"] = "FRAME"
E.db["unitframe"]["units"]["targettarget"]["debuffs"]["countFont"] = "Futura PT Medium"
E.db["unitframe"]["units"]["targettarget"]["debuffs"]["countFontSize"] = 10
E.db["unitframe"]["units"]["targettarget"]["debuffs"]["perrow"] = 4
E.db["unitframe"]["units"]["targettarget"]["height"] = 25
E.db["unitframe"]["units"]["targettarget"]["name"]["attachTextTo"] = "Frame"
E.db["unitframe"]["units"]["targettarget"]["name"]["position"] = "TOPRIGHT"
E.db["unitframe"]["units"]["targettarget"]["name"]["text_format"] = "[name:medium]"
E.db["unitframe"]["units"]["targettarget"]["name"]["yOffset"] = -4
E.db["unitframe"]["units"]["targettarget"]["power"]["enable"] = false
E.db["unitframe"]["units"]["targettarget"]["width"] = 100

end