local E, L, V, P, G = unpack(ElvUI);
local GNUI = E:GetModule("GennUI");

function GNUI:LoadOmniBarProfile()
OmniBarDB = {
	["namespaces"] = {
		["LibDualSpec-1.0"] = {
		},
	},
	["profileKeys"] = {
	},
	["profiles"] = {
		["Default"] = {
			["bars"] = {
				["OmniBar2"] = {
					["spell266779"] = true,
					["glow"] = true,
					["tooltips"] = true,
					["spell197721"] = false,
					["spell102558"] = true,
					["locked"] = true,
					["spell201430"] = true,
					["spell191427"] = true,
					["size"] = 30,
					["cooldownCount"] = true,
					["ratedBattleground"] = false,
					["unusedAlpha"] = 0.45,
					["enabled3"] = true,
					["maxIcons"] = 24,
					["arena"] = false,
					["spell304971"] = true,
					["scenario"] = false,
					["spell190319"] = true,
					["spell320674"] = true,
					["spell79140"] = true,
					["growUpward"] = true,
					["spell33891"] = true,
					["spell1719"] = true,
					["spell206491"] = true,
					["highlightTarget"] = true,
					["columns"] = 8,
					["adaptive"] = false,
					["spell12472"] = true,
					["enabled2"] = true,
					["padding"] = 2,
					["spell323764"] = true,
					["battleground"] = false,
					["spell194223"] = true,
					["spell207289"] = true,
					["spell10060"] = true,
					["spell107574"] = true,
					["multiple"] = true,
					["highlightFocus"] = false,
					["spell113858"] = true,
					["spell197871"] = true,
					["spell227847"] = true,
					["spell113860"] = true,
					["spell61336"] = true,
					["align"] = "CENTER",
					["spell15286"] = false,
					["world"] = false,
					["spell42650"] = true,
					["name"] = "Offensives",
					["position"] = {
						["relativeTo"] = "UIParent",
						["point"] = "RIGHT",
						["relativePoint"] = "RIGHT",
						["yOfs"] = 59.99997329711914,
						["xOfs"] = -516.1685180664062,
						["frameStrata"] = "MEDIUM",
					},
					["spell49206"] = true,
					["spell102543"] = true,
					["spell205021"] = true,
					["spell84714"] = true,
					["spell137619"] = false,
					["spell114049"] = true,
					["spell121471"] = true,
					["spell115080"] = true,
					["spell152262"] = true,
					["noDefault"] = true,
					["spell132578"] = true,
					["names"] = false,
					["spell123904"] = true,
					["spell323639"] = true,
					["enabled0"] = true,
					["showUnused"] = false,
					["spell137639"] = true,
					["spell49028"] = true,
					["spell31884"] = true,
					["spell279302"] = true,
					["swipeAlpha"] = 0.65,
					["spell198817"] = true,
					["center"] = false,
					["spell106951"] = true,
					["spell19574"] = true,
					["spell323673"] = true,
					["spell1122"] = true,
					["border"] = true,
					["spell102560"] = true,
					["spell13750"] = true,
					["spell204330"] = true,
					["spell51271"] = true,
					["spell167105"] = true,
					["spell12042"] = true,
					["enabled1"] = true,
					["spell30449"] = true,
				},
				["OmniBar1"] = {
					["glow"] = true,
					["spell1766"] = true,
					["tooltips"] = false,
					["spell64044"] = true,
					["spell6789"] = true,
					["spell5246"] = true,
					["locked"] = true,
					["size"] = 32,
					["spell91802"] = true,
					["spell15487"] = true,
					["spell107570"] = true,
					["unusedAlpha"] = 0.45,
					["spell305485"] = true,
					["spell187650"] = true,
					["spell204336"] = true,
					["showUnused"] = false,
					["spell2094"] = true,
					["spell106839"] = true,
					["scenario"] = false,
					["spell57994"] = true,
					["growUpward"] = false,
					["spell47476"] = true,
					["spell2139"] = true,
					["highlightTarget"] = true,
					["columns"] = 10,
					["spell96231"] = true,
					["adaptive"] = false,
					["spell99"] = true,
					["padding"] = 2,
					["battleground"] = false,
					["spell408"] = true,
					["spell119910"] = true,
					["noDefault"] = true,
					["multiple"] = true,
					["spell853"] = true,
					["center"] = true,
					["spell221562"] = true,
					["spell116705"] = true,
					["spell202137"] = true,
					["align"] = "CENTER",
					["spell47528"] = true,
					["spell46968"] = true,
					["name"] = "Interrupts & CC",
					["spell78675"] = true,
					["spell6552"] = true,
					["spell30283"] = true,
					["spell89766"] = true,
					["spell6358"] = true,
					["spell212619"] = true,
					["spell192058"] = true,
					["spell5484"] = true,
					["spell207684"] = true,
					["border"] = true,
					["names"] = false,
					["spell47481"] = true,
					["spell51514"] = true,
					["spell115078"] = true,
					["spell183752"] = true,
					["spell221527"] = true,
					["spell147362"] = true,
					["spell47482"] = true,
					["world"] = true,
					["spell205369"] = true,
					["spell119381"] = true,
					["arena"] = true,
					["spell49576"] = true,
					["highlightFocus"] = false,
					["swipeAlpha"] = 0.65,
					["cooldownCount"] = true,
					["spell19577"] = true,
					["spell211881"] = true,
					["ratedBattleground"] = true,
					["spell8122"] = true,
					["maxIcons"] = 30,
					["position"] = {
						["relativeTo"] = "UIParent",
						["point"] = "BOTTOM",
						["relativePoint"] = "BOTTOM",
						["yOfs"] = 217.277587890625,
						["xOfs"] = -0.0001458927872590721,
						["frameStrata"] = "MEDIUM",
					},
					["spell199804"] = true,
					["spell179057"] = true,
					["spell5211"] = true,
				},
				["OmniBar3"] = {
					["glow"] = true,
					["spell53480"] = true,
					["spell11426"] = true,
					["tooltips"] = true,
					["spell184662"] = true,
					["spell203651"] = false,
					["locked"] = true,
					["size"] = 30,
					["spell201318"] = true,
					["ratedBattleground"] = false,
					["unusedAlpha"] = 0.45,
					["spell86659"] = true,
					["spell109304"] = true,
					["spell116849"] = true,
					["maxIcons"] = 24,
					["showUnused"] = false,
					["spell48707"] = true,
					["scenario"] = false,
					["spell115203"] = true,
					["spell48792"] = true,
					["growUpward"] = false,
					["spell55233"] = true,
					["spell204021"] = true,
					["highlightTarget"] = true,
					["columns"] = 8,
					["adaptive"] = false,
					["spell198838"] = true,
					["spell206803"] = true,
					["padding"] = 2,
					["battleground"] = false,
					["noDefault"] = true,
					["spell31850"] = true,
					["spell118038"] = true,
					["multiple"] = true,
					["highlightFocus"] = false,
					["spell51052"] = true,
					["spell147833"] = true,
					["spell115310"] = true,
					["spell305497"] = true,
					["spell184364"] = true,
					["spell186265"] = true,
					["spell61336"] = true,
					["align"] = "CENTER",
					["spell198111"] = true,
					["arena"] = false,
					["spell212295"] = true,
					["spell108271"] = true,
					["spell207399"] = true,
					["name"] = "Defensives",
					["position"] = {
						["relativeTo"] = "UIParent",
						["point"] = "RIGHT",
						["relativePoint"] = "RIGHT",
						["yOfs"] = -235.5553741455078,
						["xOfs"] = -512.8348388671875,
						["frameStrata"] = "MEDIUM",
					},
					["spell212800"] = true,
					["spell108238"] = true,
					["cooldownCount"] = true,
					["spell31821"] = true,
					["spell199754"] = true,
					["spell22812"] = true,
					["center"] = false,
					["spell104773"] = true,
					["spell205191"] = true,
					["spell45438"] = true,
					["border"] = true,
					["names"] = false,
					["spell212182"] = true,
					["spell47585"] = true,
					["spell12975"] = true,
					["spell102342"] = true,
					["spell62618"] = true,
					["swipeAlpha"] = 0.65,
					["spell498"] = true,
					["world"] = false,
					["spell740"] = true,
					["spell33206"] = true,
					["spell23920"] = true,
					["spell871"] = true,
					["spell196718"] = true,
					["spell122278"] = true,
					["spell53271"] = true,
					["spell6940"] = true,
					["spell213981"] = true,
					["spell29166"] = true,
					["spell642"] = true,
					["spell1022"] = true,
					["spell97462"] = true,
					["spell108416"] = true,
					["spell115176"] = true,
					["spell198304"] = true,
				},
			},
		},
	},
}
end